-- Titan [SimulationCraft]
-- Description: Titan plug-in to open Simulation Craft
-- Author: r1fT
-- Version: 1.0.0.00000

local _G = getfenv(0);
local TITAN_SIMULATIONCRAFT_ID = "SimulationCraft";
local TITAN_SIMULATIONCRAFT_VER = "1.0.0.70000";
local updateTable = {TITAN_SIMULATIONCRAFT_ID, TITAN_PANEL_UPDATE_BUTTON};
local buttonlabel = "Titan Panel [SimulationCraft]"

local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local AceTimer = LibStub("AceTimer-3.0")
local OverallAvg
local EquippedAvg

function TitanPanelSimulationCraftButton_OnLoad(self)
	self.registry = {
		id = TITAN_SIMULATIONCRAFT_ID,
		version = TITAN_SIMULATIONCRAFT_VER,
		category = "Information",
		menuText = "Titan Panel [SimulationCraft]",
		buttonTextFunction = "TitanPanelSimulationCraftButton_GetButtonText", 
		tooltipTitle = "SimulationCraft",
		tooltipTextFunction = "TitanPanelSimulationCraftButton_GetTooltipText", 
		icon = "Interface\\Addons\\TitanSimulationCraft\\Icon",
		iconWidth = 16,
		controlVariables = {
			ShowIcon = true,
			ShowLabelText = true,
			DisplayOnRightSide = true
		},
		savedVariables = {
			ShowIcon = 1,
			DisplayOnRightSide = true
		}
	};
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function TitanPanelSimulationCraftButton_OnEvent(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") and (not self:IsEventRegistered("PLAYER_EQUIPMENT_CHANGED")) then
		self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	end

	if event == "PLAYER_EQUIPMENT_CHANGED" then
		self:SetScript("OnUpdate", TitanPanelSimulationCraftButton_OnUpdate)
	end
end

function TitanPanelSimulationCraftButton_OnUpdate(self)
	TitanPanelPluginHandle_OnUpdate(updateTable)
	self:SetScript("OnUpdate", nil)
end

function TitanPanelSimulationCraftButton_OnClick(self, button)
	if (button == "LeftButton") then
		local editbox=ChatEdit_ChooseBoxForSend(DEFAULT_CHAT_FRAME);
		ChatEdit_ActivateChat(editbox);
		editbox:SetText("/simc");
		ChatEdit_OnEnterPressed(editbox);
	end
end

function TitanPanelSimulationCraftButton_GetButtonText(id)
	local button, id = TitanUtils_GetButton(id, true);
	EquippedAvg = GetAverageItemLevel();
	EquippedAvg = (EquippedAvg - (EquippedAvg % 1));
	return buttonlabel, "|r";
end

function TitanPanelSimulationCraftButton_GetTooltipText()
	return "Item Level: |cFF0055FF"..EquippedAvg.."|r \n|cff00ff00Left-click for SimulationCraft export.|r";
end

function TitanPanelRightClickMenu_PrepareSimulationCraftMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_SIMULATIONCRAFT_ID].menuText);
	TitanPanelRightClickMenu_AddSpacer();
	TitanPanelRightClickMenu_AddCommand(L["TITAN_PANEL_MENU_HIDE"], TITAN_SIMULATIONCRAFT_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end


